#include <joyos.h>
#include <math.h>

//Values used in function

//Both values currently in inches
#define ROBOT_HEIGHT (10)
#define CAMERA_HEIGHT (129)

//New Structures

typedef struct RobotPosition
    {
        int x;
        int y;
        int theta;
    }RobotPosition;

typedef struct GoalPosition
    {
        int x;
        int y;
    }GoalPosition;

//Functions for path creation

RobotPosition getCurrentPosition();
int getSimpleHeading(int, int, int, int);
float getSimpleDistanceTo(int, int, int, int);
void recalibrateGyro();
int angleModulus(int);


RobotPosition getCurrentPosition()
{
    RobotPosition me;
	copy_objects();
	me.x = game.coords[0].x - game.coords[0].x *ROBOT_HEIGHT / CAMERA_HEIGHT;
	me.y= game.coords[0].y - game.coords[0].y *ROBOT_HEIGHT / CAMERA_HEIGHT;
	me.theta = game.coords[0].theta;
	return me;
}

 int getSimpleHeading(int myX, int myY, int goalX, int goalY) //for straight line paths only
{
	float distanceX = goalX - myX;
	float distanceY = goalY - myY;

	//Use trigonometry to find degree to goal - returns in radians
	float radialheading = atan2(distanceY, distanceX);

	//Convert to degrees (does this work?)
	int heading = angleModulus((int)(radialheading * 180 / 3.14159f));    
	return heading;

}

float getSimpleDistanceTo(int myX, int myY, int goalX, int goalY) //straight line distance only
{

	int32_t d2 = ((int32_t)(goalX)-(int32_t)(myX))*
                 ((int32_t)(goalX)-(int32_t)(myX)) +
                 ((int32_t)(goalY)-(int32_t)(myY))*
                 ((int32_t)(goalY)-(int32_t)(myY));

	float distanceto = sqrt(d2);

	return distanceto;
}

int angleModulus(int inputangle){
    if(inputangle > 0)
    {
        return (inputangle - (((inputangle + 180) / 360) * 360));
    } else {
        return (inputangle - (((inputangle - 180) / 360) * 360));
    }

}

int rightAngleModulus(int inputangle)
{
    if(inputangle > 0)
    {
        return (inputangle - (((inputangle + 90) / 180) * 180));
    } else {
        return (inputangle - (((inputangle - 90) / 180) * 180));
    }
}




